#
Summary: This will configure the xntp3d config files for Fermilab. 
Name: zz_ntp_configure
Version: 2.0
Release: 1
Copyright: GPL
Group: Fermi
URL: http://www.fnal.gov/cd/UNIX/linux/
Distribution: Fermi Linux v7.1.1
Vendor: Fermilab
Packager: Connie Sieh
requires: ntp,perl
obsoletes: zz_xntp3_change
%description

This package configures the ntp time daemon correctly for use at Fermilab.  It
sets the initial time from the nameservers (131.225.8.200 and 131.225.17.200) 
and configures ntpd to listen to time broadcasts from the local router of the
subdomain that the machine is on.

The /etc/ntp.conf  will be saved with a suffix of .rpmsave.

%files
%post

#
# This modifies /etc/ntp.conf
#

if [ `grep broadcastclient /etc/ntp.conf | grep [0-9].[0-9].[0-9].[0-9] | wc -l` -eq 0 ]
then
if [ -f /etc/ntp.conf.rpmsave ]
then
        mv /etc/ntp.conf.rpmsave /etc/ntp.conf.rpmsave.$$
fi

cp /etc/ntp.conf /etc/ntp.conf.rpmsave

if [ `grep broadcastclient /etc/ntp.conf | wc -l` -ne 0 ]
then
	perl -pe 's/(^broadcastclient)//;' -i /etc/ntp.conf 
	perl -pe 's/(^enable bclient)//;' -i /etc/ntp.conf 
fi

if [ -f /tmp/ntp.sh ]
then
        rm -f /tmp/ntp.sh
fi

if [ -f /etc/sysconfig/network ]
then
	export ROUTER=`grep 'GATEWAY=' /etc/sysconfig/network`
	export BCCADDR=`echo $ROUTER | sed 's/GATEWAY=//'`
else
	export BCCADDR=`route -n | grep ^0.0.0.0 | cut -c17-32`
fi

echo "cat /etc/ntp.conf.rpmsave | sed '/fudge/a\\" > /tmp/ntp.sh
echo "\\" >> /tmp/ntp.sh
echo "enable bclient\\" >> /tmp/ntp.sh
echo "broadcastclient `echo $BCCADDR`' > /etc/ntp.conf" >> /tmp/ntp.sh

sh /tmp/ntp.sh
rm /tmp/ntp.sh

perl -pe 's/server/#server/;' -i /etc/ntp.conf
perl -pe 's/fudge/#fudge/;' -i /etc/ntp.conf
perl -pe 's/multicastclient/#multicastclient/;' -i /etc/ntp.conf
fi

#
# This creates the files /etc/ntp/drift and /etc/ntp/step-tickers
#

/bin/touch /etc/ntp/drift

if [ -s /etc/ntp/step-tickers ]; then
	touch /etc/ntp/step-tickers
else
        echo "131.225.8.200 131.225.17.200" > /etc/ntp/step-tickers
fi

# This makes sure the daemon is added to the runlevels 3, 4, and 5
#

/sbin/chkconfig ntpd on

%postun

if [ -f /etc/ntp.conf -a -f /etc/ntp.conf.rpmsave ]
then
	mv -f /etc/ntp.conf.rpmsave /etc/ntp.conf
fi

#if [ -f /etc/rc.d/init.d/ntpd -a -f /etc/rc.d/init.d/ntpd.rpmsave ]
#then
#	mv -f /etc/rc.d/init.d/ntpd.rpmsave /etc/rc.d/init.d/ntpd
#fi

